INCLUDE_GEN4R   equ     4
;----------------------------------------------------------------------------
; PC-9821Gen1..Gen4 IDE BIOS patch Version 1.48 (C) 2024 ܂
;----------------------------------------------------------------------------
include macros.inc

; Global stack variables -----------------
COLOR_ATTRIB    equ     byte ptr [bp-2] ; \F
ROW             equ     word ptr [bp-4] ; \s
COLUMN          equ     word ptr [bp-6] ; \J
SegTVRAM        equ     word ptr [bp-8] ; T-VRAM̃ZOgA000/E000
HiresoFlag      equ     byte ptr [bp-10] ; 01h Hi-reso flag (bit 0)
flagset         equ     byte ptr [bp-11] ;
CheckFlags      equ     byte ptr [bp-12] ;
TypeIDEBIOS     equ     byte ptr [bp-13] ; 
ModeID          equ     byte ptr [bp-14] ; ݂̃p[^[h
equip           equ     byte ptr [bp-15] ; 00h ; Flags of SCSI,IDE,SOUND BIOS existence
MemWindowAddr   equ     byte ptr [bp-16] ; 08-BANK window address in EXROM
MemWindowNative equ     byte ptr [bp-17] ; 08-BANK window native address
MachineID       equ     byte ptr [bp-18] ; Machine ID
SECTOR_N        equ     byte ptr [bp-19]
HEAD_N          equ     byte ptr [bp-20]
ChipsetType     equ     byte ptr [bp-21]
NoteWorkAreaHi  equ     byte ptr [bp-22]

mem_bank_IOaddr equ     word ptr [bp-24] ; 0461h/0091h(nC])
SegPhysIDEBIOS  equ     word ptr [bp-26] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-28] ; IDE BIOSZOgiRAMmappingj
Seg9821         equ     word ptr [bp-30] 
SegTemp         equ     word ptr [bp-32] 
CallAddr256BS   equ     word ptr [bp-34] 

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp    program_start
OriginalDisplayLine     DW   5  ;MSG_DISP_LINE
IFDEF INCLUDE_GEN4R   
title_msg0      DB      0E5h," IDE foCX̕CHSp[^̕ύX  Version 1.48  Copyright (C) 2024 ܂ ",13,10,0
ELSE
title_msg0      DB      0E5h," IDE foCX̕CHSp[^̕ύX  Version 1.27  Copyright (C) 2024 ܂ ",13,10,0
ENDIF
.8086
program_start:  
                push    bp
                mov     bp,sp
                sub     sp,40   ; X^bNϐm 40 bytes

                xor     ax,ax           ; AL=0
                mov     equip,al        ; bit̏l
                mov     TypeIDEBIOS,al  ; =0
                mov     flagset,al
                mov     CheckFlags,al
                mov     ChipsetType,al
                mov     COLUMN,ax
                mov     SegTemp,MEM_SEG
                mov     NoteWorkAreaHi,20h
                mov     COLOR_ATTRIB,0E1h
                mov     SECTOR_N,63
                mov     HEAD_N,16
                call    ResoModeCheck   ; nC]^m[}`FbNT-VRAMZOg擾
                cld                     ; ^,RAMIDE BIOSZOg𓾂 

                call    GetDisplayLine  ; ITF TEXTʕ\s̐ݒ
                mov     dx,offset title_msg0    ; ^Cg\
                call    _puts

                call    Scan_GRPH_FK_1516
                jc      ToAvoid

                test    CheckFlags,ALREADY_PATCHED
                jnz     @f      ; pb`ς݂̂Ƃ͂Qsڂ\Ȃ
                mov     dx,offset title_msg1    ; ^Cg\
                call    _puts
                mov     dx,offset title_msg2
                call    _puts
                mov     COLUMN,6
        @@:
                call    CheckEPSONPC    ; EPSON@O
                jc      WrongMachine

                call    Exist_IDE_BIOS  ; IDE BIOS̑݃`FbN
                jc      PauseExit
                
                call    ModelCheck21    ; F8E8:3Fh @ID DXԂ
                pushf   ; DXɋ@햼|C^ԂĂ
                call    _puts   ; ̂ł\
                popf
                jc      WrongMachine

                test    flagset,F_PCIBUS
                jz      @f
                call    PCI_Check       ; PCIoXȂVend/Dev`FbN
                jc      WrongMachine    ; CY=G[Œ~iNEC chipset̏ꍇj
                test    flagset,F_PCI_NOTE
                jz      @f
                call    CheckNotePCI    ; WORK AREA RAMʒu`FbN V1.47
                jc      WrongMachine    ; ʏG[͏oȂ͂
                mov     ah,NoteWorkAreaHi
                mov     al,0
                call    digitx  ; [NGA AhX\
        @@:
                mov     dx,offset msg_CRLF      
                call    _puts   ; s
                call    CheckMemSwitch  ; XCb`̃[hݒ擾
                jc      AvoidPatch      ; CY=G[ŏI
IF 1
                test    CheckFlags,ALREADY_PATCHED
                jz      @f      ; pb`ς݂̂Ƃ͒~
                mov     dx,offset already_done
                call    _puts
                jmp     PauseExit
        @@:
ENDIF
                test    flagset,F_PCIBUS     ; V1.40
                jnz     @f
                test    flagset,F_REDWOOD    ; V1.40
                jnz     @f
                call    PeriEnvCheck    ; Lgacy486@ƔfROM`FbN
                jc      WrongMachine    ; CY=G[Œ~
        @@:

;                mov     dx,1E8Eh
;                mov     al,81h
;                out     dx,al  

                test    flagset,F_PCIBUS
                jnz     @f
                call    DisplayEquip    ; KV[@̏ꍇ\
        @@:
                call    ROMtoMEM        ; IDE BIOS MEMɓ] 8KB+8KB
                
                mov     ax,SegTemp
                mov     es,ax   ; esƗp ES=MEMseg, DS=CS
                cmp     TypeIDEBIOS,30h
                je      Gene3_Patch
                cmp     TypeIDEBIOS,40h
                je      Gene4_Patch
                cmp     TypeIDEBIOS,41h
                je      Gene41_Patch
ifdef INCLUDE_GEN4R   
                cmp     TypeIDEBIOS,44h
                je      Gene4R_Patch
endif
;Gene1_2Patch:
mov al,equip
mov ah,CheckFlags
;int 3
                call    pattern02patch    ; IDE BIOS 0`2@̃pb`
                jnc     EndOfPatch
                jmp     WrongBIOS
Gene3_Patch:
                call    pattern3patch    ;  3@̃pb`
                jnc     EndOfPatch
                jmp     WrongBIOS
Gene4_Patch:
                call    pattern4patch    ;  4@̃pb`
                jnc     EndOfPatch
                jmp     WrongBIOS
Gene41_Patch:

                call    pattern41patch    ;  4PCI@̃pb`
                jnc     EndOfPatch
                jmp     WrongBIOS
ifdef INCLUDE_GEN4R 
Gene4R_Patch:
                call    pattern4R_patch   ;  4q-PCI@ ̃pb`
                jnc     EndOfPatch
                jmp     WrongBIOS
endif
                JMP     WrongMachine    ; @`FbNSĂɘRꂽƂɗ

; SĂ̏ꍇKɗ
EndOfPatch:   ; call    SetChkSum

                mov     al,flagset
                test    al,F_PCIBUS
                jz      LegacyMachine
                call    MEMtoIDEBIOS_PCI ; ̍ƌʂRAM BIOS(PCI)ɃRs[
                jmp     PatchSuccess
LegacyMachine:
                call    MEMtoIDEBIOS    ; ̍ƌʂRAM BIOSɃRs[
PatchSuccess:   xor     ax,ax
                mov     es,ax           ; ܂ł̏ɐĂ
                or      byte ptr es:[0455h],2   ; sς݃tO𖄂ߍ
                mov     ax,0380h
                int     1Bh

ExitProgram:    call    ClearSegTemp    ; ƃNAđދ
                call    ShiftKeyCheck   ; VtgL[ŕ\ꎞ~

                mov     sp,bp
                pop     bp
;                mov     ah,4Ch
;                int     21h
                RET     ; near ^[ŏI

;--------------- Abnormal end ----------------------------
WrongMachine:   call    wait1s
                mov     dx,offset wrong_msg 
                call    _puts           ; ű@ɂ͑ΉĂ܂v\
                jmp     ExitProgram     ; G[ŏI
ToAvoid:        mov     dx,offset msg_CTRL
                call    _puts
                jmp     AvoidPatch
WrongBIOS:      
;;;;            call    Poop ; ````
                mov     dx,offset wrong_bios    ; uΉBIOSł͂Ȃv
                call    _puts
AvoidPatch:     
                mov     dx,offset msg_AvoidPatch; u~܂v 
                call    _puts
PauseExit:      call    wait1s
                call    wait1s
                call    wait1s
                jmp     ExitProgram
;----------------------------------------------------------------------------
title_msg1      DB     0E1h,"'PC-98œ삵ȂIDEfoCX(CFȂ)gp\ɁI",13,10,0
title_msg2      DB     0E1h,"@                   ",0
title_msg3      DB     0E1h,"s, ܂͑ΉłȂ.",0
absent_msg      DB     041h,"IDE BIOSoĂ܂ifBXN̐ڑj",13,10,0
wrong_bios      DB     0C1h,"ΉȂBIOSł. ",0
wrong_msg       DB     041h,"̋@ɂ͑Ή܂.",13,10,0
msg_CTRL        DB     0C1h,"CTRL܂[F7]Ă̂",0
already_done    DB     081h,"  Ƀpb`ς݂̂悤ł.   ",0
msg_AvoidPatch  DB     0C1h," pb`𒆎~܂. ",13,10,0
msg_CRLF        DB     0E1h," ",13,10,0
;--------------------------------------------------------

;--------------------------------------------------------
;       machine dependent BIOS pattern
;--------------------------------------------------------
Ptn_IDP_Sect   label word                                   ; 26ɕς
                mov     byte ptr es:[2000h],07h ; 26 C6 06 00 20 07 (6bytes)
                mov     byte ptr es:[2001h],00h ; 26 C6 06 01 20 00 (
                mov     byte ptr es:[200Ah],11h ; 26 C6 06 0A 20 3F
Ptn_IDP_Sect_end    label word

Ptn_IDP_Head    label   word
               or       byte ptr es:[2004h],03h
               DB       0EBh,07h
               nop
               or       byte ptr es:[2004h],07h
Ptn_IDP_Head_end    label   word
;--------------------------------------------------------

include pat02Gim.s
include pat3G_im.s
include pat4G_im.s
include pat4GAim.s
ifdef INCLUDE_GEN4R
include pat4GRim.s
endif
;--------------------------------------------------------
.386

;--------------------------------------------------------
;       MEMtoIDEBIOS_PCI   5C00:0-->D800:0
;--------------------------------------------------------
MEMtoIDEBIOS_PCI      PROC   near
                call    D800_RAM
                pushf
                cli     ; BIOSRAMւ̓]͊荞݋֎~Ƃ
                mov     es,SegPhysIDEBIOS
                call    MEMtoROM        ; MEM̃f[^RAMBIOSɃRs[
                popf
                call    D800_WP
                ret     ; G[Ԓl͂Ȃ
MEMtoIDEBIOS_PCI      ENDP
.8086
;--------------------------------------------------------
;       MEMtoIDEBIOS    5C00:0-->D800:0
;--------------------------------------------------------
MEMtoIDEBIOS    PROC   near
                pushf
                cli     ; BIOSRAMւ̓]͊荞݋֎~Ƃ
                call    ROMRAM486_IDE   ; ݒALbVtbV
                mov     es,SegMMapIDEBIOS
                call    MEMtoROM        ; MEM̃f[^RAMBIOSɃRs[
                call    RAMROM486_IDE   ; sݒALbVtbV
                popf
                ret     ; G[Ԓl͂Ȃ
MEMtoIDEBIOS    ENDP

;--------------------------------------------------------
;       MEMtoROM        5000:0-->ES:0   ES=RAMwindowIDE
;--------------------------------------------------------
MEMtoROM        PROC    near
                cld
                mov     cx,2000h      ; 8KB
                test    flagset,F_PCIBUS
                jz      @f
                add     cx,2000h
        @@:
                shr     cx,1
                xor     ax,ax
                mov     si,ax
                mov     di,ax
                mov     ax,SegTemp
                push    ds
                mov     ds,ax   ; ds=SegTemp, es=IDE BIOSRAMwindow
           rep  movsw
                pop     ds
                ret
MEMtoROM        ENDP

;--------------------------------------------------------
;       ROMtoMEM        ds=D800:0-->5000:0
;--------------------------------------------------------
ROMtoMEM        PROC    near
                cld
                mov     cx,2000h      ; 8KB
                test    flagset,F_PCIBUS
                jz      @f
                add     cx,2000h
        @@:
                shr     cx,1
                xor     ax,ax
                mov     si,ax
                mov     di,ax
                mov     ax,SegTemp
                push    es
                push    ds
                mov     es,ax   ; ES=AX=SegTemp
                mov     ds,SegPhysIDEBIOS   ; DXɐ^IDE BIOS̃ZOg
          rep   movsw
                pop     ds
                pop     es
                ret
ROMtoMEM        ENDP

;--------------------------------------------------------
;       ROMRAM486_IDE
;--------------------------------------------------------
ROMRAM486_IDE   PROC    near
                mov     dx,043Fh ;
                mov     al,0A0h   ; clear cache
                out     dx,al
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowAddr        ; address C000 or E000h.
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,02h   ; RAM window access enable =bit2=0
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                ret
ROMRAM486_IDE   ENDP
;--------------------------------------------------------
RAMROM486_IDE   PROC    near
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowNative      ; address 8000h or 10000h
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,06h   ; RAM window access disable =bit2=1
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                mov     dx,043Fh ;
                mov     al,0A0h  ; Invalidate CPU cache
                out     dx,al
                ret
RAMROM486_IDE   ENDP

;------------------------------
include     Machine.inc
include     ideptcom.inc
include     PCIBUS.inc
include     numeric.inc     ; l\[`
include     putstrj3.s      ; \[`
;----------------------------------
code    ends
        end     start
